package org.apithefire.servlet.wicket;

import java.util.Collections;
import java.util.Map;

import javax.servlet.Filter;

import org.apache.wicket.protocol.http.IWebApplicationFactory;
import org.apache.wicket.protocol.http.WebApplication;
import org.apache.wicket.protocol.http.WicketFilter;
import org.apithefire.servlet.dynamic.AbstractDynamicFilter;
import org.apithefire.util.lang.Path;

public abstract class DynamicWicketFilter extends AbstractDynamicFilter {
	
	public class WicketFilterImpl extends WicketFilter {

		@Override
		protected IWebApplicationFactory getApplicationFactory() {
			return new IWebApplicationFactory() {
				public WebApplication createApplication(WicketFilter filter) {
					return DynamicWicketFilter.this.getWebApplication();
				}
			};
		}
		
	}

	// TODO: should rename to newWebApplication() since it is called by factory
	public abstract WebApplication getWebApplication();
	
	public abstract Path getMappingPrefix();

	@Override
	protected Filter newFilterImpl() {
		return new WicketFilterImpl();
	}

	@Override
	public Map<String, String> getInitParamMap() {
		String mappingPrefix = getMappingPrefixPattern();
		
		return Collections.singletonMap(
				WicketFilter.FILTER_MAPPING_PARAM, mappingPrefix);
	}
	
	private String getMappingPrefixPattern() {
		Path prefix = getMappingPrefix();
		Path pattern = new Path("").concat(prefix.trim()).concat(new Path("*"));
		
		return pattern.toString();
	}
	
}
